From f0f4d885ed2fb088cadc8e25c0161d37f9e8770b Mon Sep 17 00:00:00 2001
From: Timur Pocheptsov <timur.pocheptsov@qt.io>
Date: Thu, 22 Jul 2021 15:49:30 +0200
Subject: [PATCH 211/262] doCrypt() - check the error codes
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Disabled (moved into the legacy provider) DES-CBC results in a crash,
when setting key length.

Pick-to: 6.2 6.1 5.15
Change-Id: Ie0b49424f11d8042ebecebfd3b6346263f730551
Reviewed-by: Mårten Nordheim <marten.nordheim@qt.io>
(cherry picked from commit b4942f7f0c56f2c5dcd783760a8c915463e8e744)
---
 src/network/ssl/qsslkey_openssl.cpp | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

diff --git a/src/network/ssl/qsslkey_openssl.cpp b/src/network/ssl/qsslkey_openssl.cpp
index 43cb8c6de8..10f6c6c26e 100644
--- a/src/network/ssl/qsslkey_openssl.cpp
+++ b/src/network/ssl/qsslkey_openssl.cpp
@@ -348,7 +348,12 @@ static QByteArray doCrypt(QSslKeyPrivate::Cipher cipher, const QByteArray &data,
 
     EVP_CIPHER_CTX *ctx = q_EVP_CIPHER_CTX_new();
     q_EVP_CIPHER_CTX_reset(ctx);
-    q_EVP_CipherInit(ctx, type, nullptr, nullptr, enc);
+    if (q_EVP_CipherInit(ctx, type, nullptr, nullptr, enc) != 1) {
+        q_EVP_CIPHER_CTX_free(ctx);
+        QSslSocketBackendPrivate::logAndClearErrorQueue();
+        return {};
+    }
+
     q_EVP_CIPHER_CTX_set_key_length(ctx, key.size());
     if (cipher == QSslKeyPrivate::Rc2Cbc)
         q_EVP_CIPHER_CTX_ctrl(ctx, EVP_CTRL_SET_RC2_KEY_BITS, 8 * key.size(), nullptr);
-- 
2.33.0

